Attribute VB_Name = "SaveOpenGLImage"
Public Sub SaveImageTga(bitmapFilename As String, W As GLint, H As GLint)

Dim TGAhead(1 To 18) As Byte
Dim low As Byte
Dim hi As Byte
Dim bitmapImage() As Byte
Dim i As Long
Dim backup As Byte
Dim intFileHandle As Integer
Dim longFieldDimension As Long

TGAhead(1) = 0 'picture identificator lenght
TGAhead(2) = 0 ' no palete
TGAhead(3) = 2 ' truecolor
TGAhead(4) = 0 ' no palete used
TGAhead(5) = 0
TGAhead(6) = 0
TGAhead(7) = 0
TGAhead(8) = 24 ' RGB mode
TGAhead(9) = 0  ' no X and y offset
TGAhead(10) = 0
TGAhead(11) = 0
TGAhead(12) = 0

low = W Mod 256
hi = (W - low) / 256
TGAhead(13) = low
TGAhead(14) = hi

low = H Mod 256
hi = (H - low) / 256
TGAhead(15) = low
TGAhead(16) = hi

TGAhead(17) = 24 ' pixel depth
TGAhead(18) = 0 ' format descriptor

longFieldDimension = W * H * 3
ReDim bitmapImage(1 To longFieldDimension)

glPixelStorei GL_PACK_ALIGNMENT, 1
glReadPixels 0, 0, W, H, GL_RGB, GL_UNSIGNED_BYTE, bitmapImage(1)

' BGR-> RGB conversion
For i = 1 To (longFieldDimension - 2) Step 3
    backup = bitmapImage(i) 'R
    bitmapImage(i) = bitmapImage(i + 2) 'G
    bitmapImage(i + 2) = backup
Next i
        intFileHandle = FreeFile
        Open bitmapFilename For Binary Access Write As intFileHandle
        
        Put intFileHandle, , TGAhead
        
        Put intFileHandle, , bitmapImage
        Close intFileHandle
  
End Sub
